#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 248
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 81
#define ALIAS_COUNT 1
#define TOKEN_COUNT 39
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 3

enum {
  anon_sym_LT = 1,
  anon_sym_GT = 2,
  anon_sym_SLASH_GT = 3,
  anon_sym_LT_SLASH = 4,
  anon_sym_EQ = 5,
  aux_sym_attribute_name_token1 = 6,
  anon_sym_SQUOTE = 7,
  aux_sym_quoted_attribute_value_token1 = 8,
  anon_sym_DQUOTE = 9,
  aux_sym_quoted_attribute_value_token2 = 10,
  aux_sym__text_token1 = 11,
  anon_sym_LBRACE_RBRACE = 12,
  anon_sym_LBRACE = 13,
  anon_sym_RBRACE = 14,
  anon_sym_AT = 15,
  anon_sym_html = 16,
  anon_sym_POUND = 17,
  anon_sym_if = 18,
  anon_sym_COLON = 19,
  anon_sym_else = 20,
  anon_sym_SLASH = 21,
  anon_sym_each = 22,
  anon_sym_as = 23,
  anon_sym_await = 24,
  anon_sym_then = 25,
  anon_sym_catch = 26,
  anon_sym_key = 27,
  sym__start_tag_name = 28,
  sym__script_start_tag_name = 29,
  sym__style_start_tag_name = 30,
  sym__end_tag_name = 31,
  sym_errorneous_end_tag_name = 32,
  sym__implicit_end_tag = 33,
  sym_raw_text = 34,
  sym_raw_text_expr = 35,
  sym_raw_text_await = 36,
  sym_raw_text_each = 37,
  sym_comment = 38,
  sym_document = 39,
  sym__node = 40,
  sym__statement = 41,
  sym_element = 42,
  sym_start_tag = 43,
  sym_self_closing_tag = 44,
  sym_end_tag = 45,
  sym_script_element = 46,
  sym_script_start_tag = 47,
  sym_style_element = 48,
  sym_style_start_tag = 49,
  sym_attribute = 50,
  sym_attribute_name = 51,
  sym_attribute_value = 52,
  sym_expr_attribute_value = 53,
  sym_quoted_attribute_value = 54,
  sym__text = 55,
  sym__expression = 56,
  sym_expression = 57,
  sym_html_expr = 58,
  sym_if_statement = 59,
  sym_else_if_statement = 60,
  sym_else_statement = 61,
  sym_if_start_expr = 62,
  sym_else_expr = 63,
  sym_else_if_expr = 64,
  sym_if_end_expr = 65,
  sym_each_statement = 66,
  sym_each_start_expr = 67,
  sym_each_end_expr = 68,
  sym_await_statement = 69,
  sym_then_statement = 70,
  sym_catch_statement = 71,
  sym_await_start_expr = 72,
  sym_then_expr = 73,
  sym_catch_expr = 74,
  sym_await_end_expr = 75,
  sym_key_statement = 76,
  sym_key_start_expr = 77,
  sym_key_end_expr = 78,
  aux_sym_document_repeat1 = 79,
  aux_sym_start_tag_repeat1 = 80,
  alias_sym_then = 81,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_EQ] = "=",
  [aux_sym_attribute_name_token1] = "attribute_name_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_quoted_attribute_value_token1] = "attribute_value",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_quoted_attribute_value_token2] = "attribute_value",
  [aux_sym__text_token1] = "text",
  [anon_sym_LBRACE_RBRACE] = "expression",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT] = "@",
  [anon_sym_html] = "special_block_keyword",
  [anon_sym_POUND] = "#",
  [anon_sym_if] = "special_block_keyword",
  [anon_sym_COLON] = ":",
  [anon_sym_else] = "special_block_keyword",
  [anon_sym_SLASH] = "/",
  [anon_sym_each] = "special_block_keyword",
  [anon_sym_as] = "as",
  [anon_sym_await] = "special_block_keyword",
  [anon_sym_then] = "special_block_keyword",
  [anon_sym_catch] = "special_block_keyword",
  [anon_sym_key] = "special_block_keyword",
  [sym__start_tag_name] = "tag_name",
  [sym__script_start_tag_name] = "tag_name",
  [sym__style_start_tag_name] = "tag_name",
  [sym__end_tag_name] = "tag_name",
  [sym_errorneous_end_tag_name] = "errorneous_end_tag_name",
  [sym__implicit_end_tag] = "_implicit_end_tag",
  [sym_raw_text] = "raw_text",
  [sym_raw_text_expr] = "raw_text_expr",
  [sym_raw_text_await] = "raw_text_await",
  [sym_raw_text_each] = "raw_text_each",
  [sym_comment] = "comment",
  [sym_document] = "document",
  [sym__node] = "_node",
  [sym__statement] = "_statement",
  [sym_element] = "element",
  [sym_start_tag] = "start_tag",
  [sym_self_closing_tag] = "self_closing_tag",
  [sym_end_tag] = "end_tag",
  [sym_script_element] = "script_element",
  [sym_script_start_tag] = "start_tag",
  [sym_style_element] = "style_element",
  [sym_style_start_tag] = "start_tag",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym_attribute_value] = "attribute_value",
  [sym_expr_attribute_value] = "expr_attribute_value",
  [sym_quoted_attribute_value] = "quoted_attribute_value",
  [sym__text] = "_text",
  [sym__expression] = "_expression",
  [sym_expression] = "expression",
  [sym_html_expr] = "html_expr",
  [sym_if_statement] = "if_statement",
  [sym_else_if_statement] = "else_if_statement",
  [sym_else_statement] = "else_statement",
  [sym_if_start_expr] = "if_start_expr",
  [sym_else_expr] = "else_expr",
  [sym_else_if_expr] = "else_if_expr",
  [sym_if_end_expr] = "if_end_expr",
  [sym_each_statement] = "each_statement",
  [sym_each_start_expr] = "each_start_expr",
  [sym_each_end_expr] = "each_end_expr",
  [sym_await_statement] = "await_statement",
  [sym_then_statement] = "then_statement",
  [sym_catch_statement] = "catch_statement",
  [sym_await_start_expr] = "await_start_expr",
  [sym_then_expr] = "then_expr",
  [sym_catch_expr] = "catch_expr",
  [sym_await_end_expr] = "await_end_expr",
  [sym_key_statement] = "key_statement",
  [sym_key_start_expr] = "key_start_expr",
  [sym_key_end_expr] = "key_end_expr",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_start_tag_repeat1] = "start_tag_repeat1",
  [alias_sym_then] = "then",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_attribute_name_token1] = aux_sym_attribute_name_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_quoted_attribute_value_token1] = sym_attribute_value,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_quoted_attribute_value_token2] = sym_attribute_value,
  [aux_sym__text_token1] = aux_sym__text_token1,
  [anon_sym_LBRACE_RBRACE] = sym_expression,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_html] = anon_sym_html,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_if] = anon_sym_html,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_else] = anon_sym_html,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_each] = anon_sym_html,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_await] = anon_sym_html,
  [anon_sym_then] = anon_sym_html,
  [anon_sym_catch] = anon_sym_html,
  [anon_sym_key] = anon_sym_html,
  [sym__start_tag_name] = sym__start_tag_name,
  [sym__script_start_tag_name] = sym__start_tag_name,
  [sym__style_start_tag_name] = sym__start_tag_name,
  [sym__end_tag_name] = sym__start_tag_name,
  [sym_errorneous_end_tag_name] = sym_errorneous_end_tag_name,
  [sym__implicit_end_tag] = sym__implicit_end_tag,
  [sym_raw_text] = sym_raw_text,
  [sym_raw_text_expr] = sym_raw_text_expr,
  [sym_raw_text_await] = sym_raw_text_await,
  [sym_raw_text_each] = sym_raw_text_each,
  [sym_comment] = sym_comment,
  [sym_document] = sym_document,
  [sym__node] = sym__node,
  [sym__statement] = sym__statement,
  [sym_element] = sym_element,
  [sym_start_tag] = sym_start_tag,
  [sym_self_closing_tag] = sym_self_closing_tag,
  [sym_end_tag] = sym_end_tag,
  [sym_script_element] = sym_script_element,
  [sym_script_start_tag] = sym_start_tag,
  [sym_style_element] = sym_style_element,
  [sym_style_start_tag] = sym_start_tag,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym_attribute_value] = sym_attribute_value,
  [sym_expr_attribute_value] = sym_expr_attribute_value,
  [sym_quoted_attribute_value] = sym_quoted_attribute_value,
  [sym__text] = sym__text,
  [sym__expression] = sym__expression,
  [sym_expression] = sym_expression,
  [sym_html_expr] = sym_html_expr,
  [sym_if_statement] = sym_if_statement,
  [sym_else_if_statement] = sym_else_if_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_if_start_expr] = sym_if_start_expr,
  [sym_else_expr] = sym_else_expr,
  [sym_else_if_expr] = sym_else_if_expr,
  [sym_if_end_expr] = sym_if_end_expr,
  [sym_each_statement] = sym_each_statement,
  [sym_each_start_expr] = sym_each_start_expr,
  [sym_each_end_expr] = sym_each_end_expr,
  [sym_await_statement] = sym_await_statement,
  [sym_then_statement] = sym_then_statement,
  [sym_catch_statement] = sym_catch_statement,
  [sym_await_start_expr] = sym_await_start_expr,
  [sym_then_expr] = sym_then_expr,
  [sym_catch_expr] = sym_catch_expr,
  [sym_await_end_expr] = sym_await_end_expr,
  [sym_key_statement] = sym_key_statement,
  [sym_key_start_expr] = sym_key_start_expr,
  [sym_key_end_expr] = sym_key_end_expr,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_start_tag_repeat1] = aux_sym_start_tag_repeat1,
  [alias_sym_then] = alias_sym_then,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_attribute_name_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__text_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE_RBRACE] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_html] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_each] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_key] = {
    .visible = true,
    .named = true,
  },
  [sym__start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__script_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__style_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym_errorneous_end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__implicit_end_tag] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_text] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_await] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_each] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym__node] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_end_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_script_element] = {
    .visible = true,
    .named = true,
  },
  [sym_script_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_style_element] = {
    .visible = true,
    .named = true,
  },
  [sym_style_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym__text] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_html_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_else_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_if_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_each_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_each_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_await_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_then_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_await_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_then_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_await_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_key_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_key_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_key_end_expr] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_start_tag_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_then] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_attribute_name,
  },
  [2] = {
    [4] = alias_sym_then,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym_expression, 2,
    sym_expression,
    sym_attribute_name,
  0,
};

static inline bool aux_sym_attribute_name_token1_character_set_1(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= '\'' || (c < '{'
      ? (c < '<'
        ? c == '/'
        : c <= '>')
      : (c <= '{' || c == '}'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(29);
      if (lookahead == '"') ADVANCE(39);
      if (lookahead == '#') ADVANCE(50);
      if (lookahead == '\'') ADVANCE(36);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == '@') ADVANCE(48);
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'k') ADVANCE(11);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == '{') ADVANCE(46);
      if (lookahead == '}') ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(39);
      if (lookahead == '\'') ADVANCE(36);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '}') ADVANCE(35);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(39);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(41);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(50);
      if (lookahead == '/') ADVANCE(54);
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == '@') ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (lookahead != 0) ADVANCE(38);
      END_STATE();
    case 5:
      if (lookahead == '>') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(23);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(18);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(26);
      END_STATE();
    case 9:
      if (lookahead == 'c') ADVANCE(15);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(16);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(21);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(60);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(12);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(25);
      END_STATE();
    case 19:
      if (lookahead == 'l') ADVANCE(49);
      END_STATE();
    case 20:
      if (lookahead == 'm') ADVANCE(19);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(57);
      if (lookahead == 'w') ADVANCE(7);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(20);
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 26:
      if (lookahead == 't') ADVANCE(10);
      END_STATE();
    case 27:
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 28:
      if (eof) ADVANCE(29);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '{') ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(43);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(33);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(aux_sym_attribute_name_token1);
      if (!aux_sym_attribute_name_token1_character_set_1(lookahead)) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(41);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(43);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LBRACE_RBRACE);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '}') ADVANCE(44);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_html);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '>') ADVANCE(32);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_each);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_key);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 28, .external_lex_state = 2},
  [2] = {.lex_state = 28, .external_lex_state = 2},
  [3] = {.lex_state = 28, .external_lex_state = 2},
  [4] = {.lex_state = 28, .external_lex_state = 2},
  [5] = {.lex_state = 28, .external_lex_state = 2},
  [6] = {.lex_state = 28, .external_lex_state = 2},
  [7] = {.lex_state = 28, .external_lex_state = 2},
  [8] = {.lex_state = 28, .external_lex_state = 2},
  [9] = {.lex_state = 28, .external_lex_state = 2},
  [10] = {.lex_state = 28, .external_lex_state = 2},
  [11] = {.lex_state = 28, .external_lex_state = 2},
  [12] = {.lex_state = 28, .external_lex_state = 2},
  [13] = {.lex_state = 28, .external_lex_state = 2},
  [14] = {.lex_state = 28, .external_lex_state = 3},
  [15] = {.lex_state = 28, .external_lex_state = 3},
  [16] = {.lex_state = 28, .external_lex_state = 2},
  [17] = {.lex_state = 28, .external_lex_state = 2},
  [18] = {.lex_state = 28, .external_lex_state = 3},
  [19] = {.lex_state = 28, .external_lex_state = 2},
  [20] = {.lex_state = 28, .external_lex_state = 3},
  [21] = {.lex_state = 28, .external_lex_state = 2},
  [22] = {.lex_state = 28, .external_lex_state = 3},
  [23] = {.lex_state = 28, .external_lex_state = 2},
  [24] = {.lex_state = 28, .external_lex_state = 2},
  [25] = {.lex_state = 28, .external_lex_state = 2},
  [26] = {.lex_state = 28, .external_lex_state = 2},
  [27] = {.lex_state = 28, .external_lex_state = 2},
  [28] = {.lex_state = 28, .external_lex_state = 2},
  [29] = {.lex_state = 28, .external_lex_state = 2},
  [30] = {.lex_state = 28, .external_lex_state = 2},
  [31] = {.lex_state = 28, .external_lex_state = 2},
  [32] = {.lex_state = 28, .external_lex_state = 2},
  [33] = {.lex_state = 28, .external_lex_state = 2},
  [34] = {.lex_state = 28, .external_lex_state = 2},
  [35] = {.lex_state = 28, .external_lex_state = 2},
  [36] = {.lex_state = 28, .external_lex_state = 2},
  [37] = {.lex_state = 28, .external_lex_state = 2},
  [38] = {.lex_state = 28, .external_lex_state = 2},
  [39] = {.lex_state = 28, .external_lex_state = 2},
  [40] = {.lex_state = 28, .external_lex_state = 2},
  [41] = {.lex_state = 1},
  [42] = {.lex_state = 1},
  [43] = {.lex_state = 1, .external_lex_state = 4},
  [44] = {.lex_state = 1, .external_lex_state = 4},
  [45] = {.lex_state = 1, .external_lex_state = 4},
  [46] = {.lex_state = 1, .external_lex_state = 4},
  [47] = {.lex_state = 1, .external_lex_state = 4},
  [48] = {.lex_state = 28, .external_lex_state = 3},
  [49] = {.lex_state = 28, .external_lex_state = 3},
  [50] = {.lex_state = 28, .external_lex_state = 3},
  [51] = {.lex_state = 28, .external_lex_state = 3},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 28, .external_lex_state = 3},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 28, .external_lex_state = 3},
  [56] = {.lex_state = 28, .external_lex_state = 3},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 28, .external_lex_state = 3},
  [59] = {.lex_state = 28, .external_lex_state = 3},
  [60] = {.lex_state = 28, .external_lex_state = 3},
  [61] = {.lex_state = 28, .external_lex_state = 3},
  [62] = {.lex_state = 28, .external_lex_state = 3},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 28, .external_lex_state = 3},
  [65] = {.lex_state = 28, .external_lex_state = 3},
  [66] = {.lex_state = 28, .external_lex_state = 3},
  [67] = {.lex_state = 28, .external_lex_state = 3},
  [68] = {.lex_state = 28, .external_lex_state = 3},
  [69] = {.lex_state = 28, .external_lex_state = 3},
  [70] = {.lex_state = 28, .external_lex_state = 3},
  [71] = {.lex_state = 28, .external_lex_state = 3},
  [72] = {.lex_state = 28, .external_lex_state = 3},
  [73] = {.lex_state = 28, .external_lex_state = 3},
  [74] = {.lex_state = 28, .external_lex_state = 3},
  [75] = {.lex_state = 28, .external_lex_state = 3},
  [76] = {.lex_state = 28, .external_lex_state = 3},
  [77] = {.lex_state = 28, .external_lex_state = 3},
  [78] = {.lex_state = 28, .external_lex_state = 3},
  [79] = {.lex_state = 28, .external_lex_state = 3},
  [80] = {.lex_state = 28, .external_lex_state = 3},
  [81] = {.lex_state = 28, .external_lex_state = 3},
  [82] = {.lex_state = 28, .external_lex_state = 3},
  [83] = {.lex_state = 28, .external_lex_state = 3},
  [84] = {.lex_state = 28, .external_lex_state = 3},
  [85] = {.lex_state = 28, .external_lex_state = 3},
  [86] = {.lex_state = 1},
  [87] = {.lex_state = 28, .external_lex_state = 3},
  [88] = {.lex_state = 28, .external_lex_state = 2},
  [89] = {.lex_state = 28, .external_lex_state = 2},
  [90] = {.lex_state = 28, .external_lex_state = 2},
  [91] = {.lex_state = 28, .external_lex_state = 2},
  [92] = {.lex_state = 28, .external_lex_state = 2},
  [93] = {.lex_state = 28, .external_lex_state = 2},
  [94] = {.lex_state = 28, .external_lex_state = 2},
  [95] = {.lex_state = 28, .external_lex_state = 2},
  [96] = {.lex_state = 28, .external_lex_state = 2},
  [97] = {.lex_state = 28, .external_lex_state = 2},
  [98] = {.lex_state = 28, .external_lex_state = 2},
  [99] = {.lex_state = 28, .external_lex_state = 2},
  [100] = {.lex_state = 28, .external_lex_state = 2},
  [101] = {.lex_state = 28, .external_lex_state = 2},
  [102] = {.lex_state = 28, .external_lex_state = 2},
  [103] = {.lex_state = 28, .external_lex_state = 2},
  [104] = {.lex_state = 28, .external_lex_state = 2},
  [105] = {.lex_state = 28, .external_lex_state = 2},
  [106] = {.lex_state = 28, .external_lex_state = 2},
  [107] = {.lex_state = 28, .external_lex_state = 2},
  [108] = {.lex_state = 28, .external_lex_state = 2},
  [109] = {.lex_state = 28, .external_lex_state = 2},
  [110] = {.lex_state = 28, .external_lex_state = 2},
  [111] = {.lex_state = 28, .external_lex_state = 2},
  [112] = {.lex_state = 28, .external_lex_state = 2},
  [113] = {.lex_state = 28, .external_lex_state = 2},
  [114] = {.lex_state = 28, .external_lex_state = 2},
  [115] = {.lex_state = 28, .external_lex_state = 2},
  [116] = {.lex_state = 28, .external_lex_state = 2},
  [117] = {.lex_state = 28, .external_lex_state = 2},
  [118] = {.lex_state = 28, .external_lex_state = 2},
  [119] = {.lex_state = 28, .external_lex_state = 2},
  [120] = {.lex_state = 28, .external_lex_state = 2},
  [121] = {.lex_state = 3, .external_lex_state = 5},
  [122] = {.lex_state = 28, .external_lex_state = 2},
  [123] = {.lex_state = 1, .external_lex_state = 4},
  [124] = {.lex_state = 28, .external_lex_state = 2},
  [125] = {.lex_state = 28, .external_lex_state = 2},
  [126] = {.lex_state = 3, .external_lex_state = 5},
  [127] = {.lex_state = 28, .external_lex_state = 2},
  [128] = {.lex_state = 28, .external_lex_state = 2},
  [129] = {.lex_state = 3, .external_lex_state = 5},
  [130] = {.lex_state = 28, .external_lex_state = 2},
  [131] = {.lex_state = 28, .external_lex_state = 2},
  [132] = {.lex_state = 28, .external_lex_state = 2},
  [133] = {.lex_state = 1, .external_lex_state = 4},
  [134] = {.lex_state = 3, .external_lex_state = 5},
  [135] = {.lex_state = 28, .external_lex_state = 2},
  [136] = {.lex_state = 28, .external_lex_state = 2},
  [137] = {.lex_state = 3, .external_lex_state = 5},
  [138] = {.lex_state = 28, .external_lex_state = 2},
  [139] = {.lex_state = 28, .external_lex_state = 2},
  [140] = {.lex_state = 3, .external_lex_state = 5},
  [141] = {.lex_state = 28, .external_lex_state = 2},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 3, .external_lex_state = 5},
  [144] = {.lex_state = 1, .external_lex_state = 4},
  [145] = {.lex_state = 3, .external_lex_state = 5},
  [146] = {.lex_state = 3, .external_lex_state = 5},
  [147] = {.lex_state = 3, .external_lex_state = 5},
  [148] = {.lex_state = 3, .external_lex_state = 5},
  [149] = {.lex_state = 1, .external_lex_state = 4},
  [150] = {.lex_state = 3, .external_lex_state = 5},
  [151] = {.lex_state = 1, .external_lex_state = 4},
  [152] = {.lex_state = 1, .external_lex_state = 4},
  [153] = {.lex_state = 3, .external_lex_state = 5},
  [154] = {.lex_state = 1, .external_lex_state = 4},
  [155] = {.lex_state = 1, .external_lex_state = 4},
  [156] = {.lex_state = 3, .external_lex_state = 5},
  [157] = {.lex_state = 1, .external_lex_state = 4},
  [158] = {.lex_state = 1},
  [159] = {.lex_state = 1},
  [160] = {.lex_state = 1},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 0, .external_lex_state = 5},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 0, .external_lex_state = 6},
  [165] = {.lex_state = 0, .external_lex_state = 5},
  [166] = {.lex_state = 0, .external_lex_state = 7},
  [167] = {.lex_state = 0, .external_lex_state = 7},
  [168] = {.lex_state = 0, .external_lex_state = 6},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 1},
  [172] = {.lex_state = 0, .external_lex_state = 7},
  [173] = {.lex_state = 1},
  [174] = {.lex_state = 0, .external_lex_state = 7},
  [175] = {.lex_state = 0},
  [176] = {.lex_state = 0},
  [177] = {.lex_state = 0, .external_lex_state = 5},
  [178] = {.lex_state = 2},
  [179] = {.lex_state = 4},
  [180] = {.lex_state = 0, .external_lex_state = 7},
  [181] = {.lex_state = 0, .external_lex_state = 5},
  [182] = {.lex_state = 0, .external_lex_state = 8},
  [183] = {.lex_state = 0, .external_lex_state = 9},
  [184] = {.lex_state = 0, .external_lex_state = 5},
  [185] = {.lex_state = 0, .external_lex_state = 5},
  [186] = {.lex_state = 0},
  [187] = {.lex_state = 0, .external_lex_state = 7},
  [188] = {.lex_state = 0, .external_lex_state = 7},
  [189] = {.lex_state = 0, .external_lex_state = 5},
  [190] = {.lex_state = 0, .external_lex_state = 7},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 2},
  [193] = {.lex_state = 0},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 4},
  [196] = {.lex_state = 0},
  [197] = {.lex_state = 0},
  [198] = {.lex_state = 0, .external_lex_state = 5},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 0},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 0},
  [208] = {.lex_state = 0},
  [209] = {.lex_state = 0},
  [210] = {.lex_state = 0, .external_lex_state = 10},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 0},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0},
  [216] = {.lex_state = 0, .external_lex_state = 5},
  [217] = {.lex_state = 0, .external_lex_state = 5},
  [218] = {.lex_state = 0, .external_lex_state = 5},
  [219] = {.lex_state = 0},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 0, .external_lex_state = 5},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 0},
  [226] = {.lex_state = 0},
  [227] = {.lex_state = 0},
  [228] = {.lex_state = 0},
  [229] = {.lex_state = 0},
  [230] = {.lex_state = 0},
  [231] = {.lex_state = 0},
  [232] = {.lex_state = 0},
  [233] = {.lex_state = 0},
  [234] = {.lex_state = 0},
  [235] = {.lex_state = 0, .external_lex_state = 10},
  [236] = {.lex_state = 0, .external_lex_state = 5},
  [237] = {.lex_state = 0},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 0},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
};

enum {
  ts_external_token__start_tag_name = 0,
  ts_external_token__script_start_tag_name = 1,
  ts_external_token__style_start_tag_name = 2,
  ts_external_token__end_tag_name = 3,
  ts_external_token_errorneous_end_tag_name = 4,
  ts_external_token_SLASH_GT = 5,
  ts_external_token__implicit_end_tag = 6,
  ts_external_token_raw_text = 7,
  ts_external_token_raw_text_expr = 8,
  ts_external_token_raw_text_await = 9,
  ts_external_token_raw_text_each = 10,
  ts_external_token_comment = 11,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__start_tag_name] = sym__start_tag_name,
  [ts_external_token__script_start_tag_name] = sym__script_start_tag_name,
  [ts_external_token__style_start_tag_name] = sym__style_start_tag_name,
  [ts_external_token__end_tag_name] = sym__end_tag_name,
  [ts_external_token_errorneous_end_tag_name] = sym_errorneous_end_tag_name,
  [ts_external_token_SLASH_GT] = anon_sym_SLASH_GT,
  [ts_external_token__implicit_end_tag] = sym__implicit_end_tag,
  [ts_external_token_raw_text] = sym_raw_text,
  [ts_external_token_raw_text_expr] = sym_raw_text_expr,
  [ts_external_token_raw_text_await] = sym_raw_text_await,
  [ts_external_token_raw_text_each] = sym_raw_text_each,
  [ts_external_token_comment] = sym_comment,
};

static bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
    [ts_external_token__end_tag_name] = true,
    [ts_external_token_errorneous_end_tag_name] = true,
    [ts_external_token_SLASH_GT] = true,
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_raw_text] = true,
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_await] = true,
    [ts_external_token_raw_text_each] = true,
    [ts_external_token_comment] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token_SLASH_GT] = true,
  },
  [5] = {
    [ts_external_token_raw_text_expr] = true,
  },
  [6] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
  },
  [7] = {
    [ts_external_token_raw_text] = true,
  },
  [8] = {
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_await] = true,
  },
  [9] = {
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_each] = true,
  },
  [10] = {
    [ts_external_token__end_tag_name] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH_GT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_html] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_each] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_key] = ACTIONS(1),
    [sym__start_tag_name] = ACTIONS(1),
    [sym__script_start_tag_name] = ACTIONS(1),
    [sym__style_start_tag_name] = ACTIONS(1),
    [sym__end_tag_name] = ACTIONS(1),
    [sym_errorneous_end_tag_name] = ACTIONS(1),
    [sym__implicit_end_tag] = ACTIONS(1),
    [sym_raw_text] = ACTIONS(1),
    [sym_raw_text_expr] = ACTIONS(1),
    [sym_raw_text_await] = ACTIONS(1),
    [sym_raw_text_each] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(219),
    [sym__node] = STATE(37),
    [sym__statement] = STATE(37),
    [sym_element] = STATE(37),
    [sym_start_tag] = STATE(18),
    [sym_self_closing_tag] = STATE(90),
    [sym_script_element] = STATE(37),
    [sym_script_start_tag] = STATE(166),
    [sym_style_element] = STATE(37),
    [sym_style_start_tag] = STATE(167),
    [sym__text] = STATE(37),
    [sym__expression] = STATE(37),
    [sym_expression] = STATE(37),
    [sym_html_expr] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_if_start_expr] = STATE(9),
    [sym_each_statement] = STATE(37),
    [sym_each_start_expr] = STATE(31),
    [sym_await_statement] = STATE(37),
    [sym_await_start_expr] = STATE(11),
    [sym_key_statement] = STATE(37),
    [sym_key_start_expr] = STATE(25),
    [aux_sym_document_repeat1] = STATE(37),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(5),
    [aux_sym__text_token1] = ACTIONS(7),
    [anon_sym_LBRACE_RBRACE] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [sym_comment] = ACTIONS(7),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(15), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    STATE(2), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(26), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(13), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(66), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(6), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [65] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(10), 1,
      sym_else_if_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(104), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [130] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(25), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(19), 1,
      sym_then_expr,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(38), 1,
      sym_catch_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(114), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [195] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(29), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(2), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(26), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(27), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(80), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(13), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [260] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(2), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(26), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(51), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [325] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(33), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(21), 1,
      sym_then_expr,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(30), 1,
      sym_catch_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(31), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(77), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(12), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [390] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(10), 1,
      sym_else_if_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(108), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [455] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(10), 1,
      sym_else_if_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(37), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(95), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(8), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [520] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(10), 1,
      sym_else_if_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(41), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(107), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(3), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [585] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(25), 1,
      anon_sym_LBRACE,
    ACTIONS(47), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(19), 1,
      sym_then_expr,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(38), 1,
      sym_catch_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(45), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(97), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(4), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [650] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(21), 1,
      sym_then_expr,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(30), 1,
      sym_catch_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(60), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [715] = 16,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(2), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(26), 1,
      sym_else_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(65), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [780] = 16,
    ACTIONS(49), 1,
      anon_sym_LT,
    ACTIONS(51), 1,
      anon_sym_LT_SLASH,
    ACTIONS(55), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(59), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_if_start_expr,
    STATE(7), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_start_tag,
    STATE(28), 1,
      sym_key_start_expr,
    STATE(33), 1,
      sym_each_start_expr,
    STATE(84), 1,
      sym_end_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(172), 1,
      sym_script_start_tag,
    STATE(174), 1,
      sym_style_start_tag,
    ACTIONS(53), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(15), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [843] = 16,
    ACTIONS(49), 1,
      anon_sym_LT,
    ACTIONS(51), 1,
      anon_sym_LT_SLASH,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(63), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(65), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_if_start_expr,
    STATE(7), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_start_tag,
    STATE(28), 1,
      sym_key_start_expr,
    STATE(33), 1,
      sym_each_start_expr,
    STATE(72), 1,
      sym_end_tag,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(172), 1,
      sym_script_start_tag,
    STATE(174), 1,
      sym_style_start_tag,
    ACTIONS(61), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(22), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [906] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(30), 1,
      sym_catch_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(50), 2,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [967] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(69), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(38), 1,
      sym_catch_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(110), 2,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1028] = 16,
    ACTIONS(49), 1,
      anon_sym_LT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_LT_SLASH,
    ACTIONS(75), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(77), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_if_start_expr,
    STATE(7), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_start_tag,
    STATE(28), 1,
      sym_key_start_expr,
    STATE(33), 1,
      sym_each_start_expr,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(91), 1,
      sym_end_tag,
    STATE(172), 1,
      sym_script_start_tag,
    STATE(174), 1,
      sym_style_start_tag,
    ACTIONS(73), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(20), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1091] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(69), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(38), 1,
      sym_catch_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(79), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(112), 2,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(17), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1152] = 16,
    ACTIONS(49), 1,
      anon_sym_LT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(63), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(71), 1,
      anon_sym_LT_SLASH,
    ACTIONS(83), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_if_start_expr,
    STATE(7), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_start_tag,
    STATE(28), 1,
      sym_key_start_expr,
    STATE(33), 1,
      sym_each_start_expr,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(102), 1,
      sym_end_tag,
    STATE(172), 1,
      sym_script_start_tag,
    STATE(174), 1,
      sym_style_start_tag,
    ACTIONS(61), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(22), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1215] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(30), 1,
      sym_catch_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(85), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(62), 2,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(16), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1276] = 15,
    ACTIONS(89), 1,
      anon_sym_LT,
    ACTIONS(92), 1,
      anon_sym_LT_SLASH,
    ACTIONS(97), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(100), 1,
      anon_sym_LBRACE,
    ACTIONS(103), 1,
      sym__implicit_end_tag,
    STATE(5), 1,
      sym_if_start_expr,
    STATE(7), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_start_tag,
    STATE(28), 1,
      sym_key_start_expr,
    STATE(33), 1,
      sym_each_start_expr,
    STATE(85), 1,
      sym_self_closing_tag,
    STATE(172), 1,
      sym_script_start_tag,
    STATE(174), 1,
      sym_style_start_tag,
    ACTIONS(94), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(22), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1336] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(105), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(64), 1,
      sym_each_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1393] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(115), 1,
      sym_key_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1450] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(111), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(98), 1,
      sym_key_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(109), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(24), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1507] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(115), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(117), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(67), 1,
      sym_if_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(113), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(35), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1564] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(119), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(49), 1,
      sym_await_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1621] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(123), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(125), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(76), 1,
      sym_key_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(121), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(39), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1678] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(129), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(106), 1,
      sym_if_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(127), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(32), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1735] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(119), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(61), 1,
      sym_await_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(133), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(27), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1792] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(139), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(96), 1,
      sym_each_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(137), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(34), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1849] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(103), 1,
      sym_if_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1906] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(105), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_LBRACE_RBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(78), 1,
      sym_each_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(143), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(23), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1963] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(109), 1,
      sym_each_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2020] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(117), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(53), 1,
      sym_if_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2077] = 14,
    ACTIONS(103), 1,
      ts_builtin_sym_end,
    ACTIONS(147), 1,
      anon_sym_LT,
    ACTIONS(153), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(156), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(150), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2134] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(159), 1,
      ts_builtin_sym_end,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2191] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(163), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(165), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(113), 1,
      sym_await_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(161), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(40), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2248] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(125), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(59), 1,
      sym_key_end_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2305] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE_RBRACE,
    ACTIONS(165), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(25), 1,
      sym_key_start_expr,
    STATE(31), 1,
      sym_each_start_expr,
    STATE(90), 1,
      sym_self_closing_tag,
    STATE(111), 1,
      sym_await_end_expr,
    STATE(166), 1,
      sym_script_start_tag,
    STATE(167), 1,
      sym_style_start_tag,
    ACTIONS(19), 2,
      sym_comment,
      aux_sym__text_token1,
    STATE(36), 14,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2362] = 6,
    ACTIONS(167), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(169), 1,
      anon_sym_SQUOTE,
    ACTIONS(171), 1,
      anon_sym_DQUOTE,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_expression,
    STATE(160), 3,
      sym_attribute_value,
      sym_expr_attribute_value,
      sym_quoted_attribute_value,
  [2383] = 6,
    ACTIONS(175), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(179), 1,
      anon_sym_DQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    STATE(155), 1,
      sym_expression,
    STATE(154), 3,
      sym_attribute_value,
      sym_expr_attribute_value,
      sym_quoted_attribute_value,
  [2404] = 7,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_GT,
    ACTIONS(185), 1,
      anon_sym_SLASH_GT,
    ACTIONS(187), 1,
      aux_sym_attribute_name_token1,
    STATE(123), 1,
      sym_attribute_name,
    STATE(157), 1,
      sym_expression,
    STATE(47), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2427] = 6,
    ACTIONS(191), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(194), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_attribute_name,
    STATE(157), 1,
      sym_expression,
    ACTIONS(189), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(44), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2448] = 7,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(183), 1,
      anon_sym_GT,
    ACTIONS(187), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(197), 1,
      anon_sym_SLASH_GT,
    STATE(123), 1,
      sym_attribute_name,
    STATE(157), 1,
      sym_expression,
    STATE(46), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2471] = 7,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(187), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(199), 1,
      anon_sym_GT,
    ACTIONS(201), 1,
      anon_sym_SLASH_GT,
    STATE(123), 1,
      sym_attribute_name,
    STATE(157), 1,
      sym_expression,
    STATE(44), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2494] = 7,
    ACTIONS(181), 1,
      anon_sym_LBRACE,
    ACTIONS(187), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(199), 1,
      anon_sym_GT,
    ACTIONS(203), 1,
      anon_sym_SLASH_GT,
    STATE(123), 1,
      sym_attribute_name,
    STATE(157), 1,
      sym_expression,
    STATE(44), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2517] = 2,
    ACTIONS(207), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(205), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2529] = 2,
    ACTIONS(211), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(209), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2541] = 2,
    ACTIONS(215), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(213), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2553] = 2,
    ACTIONS(219), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(217), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2565] = 6,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(221), 1,
      anon_sym_GT,
    ACTIONS(223), 1,
      aux_sym_attribute_name_token1,
    STATE(159), 1,
      sym_attribute_name,
    STATE(163), 1,
      sym_expression,
    STATE(57), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2585] = 2,
    ACTIONS(227), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(225), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2597] = 6,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(223), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(229), 1,
      anon_sym_GT,
    STATE(159), 1,
      sym_attribute_name,
    STATE(163), 1,
      sym_expression,
    STATE(57), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2617] = 2,
    ACTIONS(233), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(231), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2629] = 2,
    ACTIONS(237), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(235), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2641] = 6,
    ACTIONS(189), 1,
      anon_sym_GT,
    ACTIONS(239), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(242), 1,
      anon_sym_LBRACE,
    STATE(159), 1,
      sym_attribute_name,
    STATE(163), 1,
      sym_expression,
    STATE(57), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2661] = 2,
    ACTIONS(247), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(245), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2673] = 2,
    ACTIONS(251), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(249), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2685] = 2,
    ACTIONS(255), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(253), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2697] = 2,
    ACTIONS(259), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(257), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2709] = 2,
    ACTIONS(263), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(261), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2721] = 6,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(223), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(265), 1,
      anon_sym_GT,
    STATE(159), 1,
      sym_attribute_name,
    STATE(163), 1,
      sym_expression,
    STATE(52), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2741] = 2,
    ACTIONS(269), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(267), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2753] = 2,
    ACTIONS(273), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(271), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2765] = 2,
    ACTIONS(277), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(275), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2777] = 2,
    ACTIONS(281), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(279), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2789] = 2,
    ACTIONS(285), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(283), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2801] = 2,
    ACTIONS(289), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(287), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2813] = 2,
    ACTIONS(293), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(291), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2825] = 2,
    ACTIONS(297), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(295), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2837] = 2,
    ACTIONS(301), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(299), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2849] = 2,
    ACTIONS(305), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(303), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2861] = 2,
    ACTIONS(309), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(307), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2873] = 2,
    ACTIONS(313), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(311), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2885] = 2,
    ACTIONS(317), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(315), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2897] = 2,
    ACTIONS(321), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(319), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2909] = 2,
    ACTIONS(325), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(323), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2921] = 2,
    ACTIONS(329), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(327), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2933] = 2,
    ACTIONS(333), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(331), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2945] = 2,
    ACTIONS(337), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(335), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2957] = 2,
    ACTIONS(341), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(339), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2969] = 2,
    ACTIONS(345), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(343), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2981] = 2,
    ACTIONS(349), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(347), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [2993] = 2,
    ACTIONS(353), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(351), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3005] = 6,
    ACTIONS(173), 1,
      anon_sym_LBRACE,
    ACTIONS(223), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(355), 1,
      anon_sym_GT,
    STATE(159), 1,
      sym_attribute_name,
    STATE(163), 1,
      sym_expression,
    STATE(54), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [3025] = 2,
    ACTIONS(359), 3,
      sym__implicit_end_tag,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(357), 4,
      anon_sym_LT,
      anon_sym_LT_SLASH,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3037] = 2,
    ACTIONS(291), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(293), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3048] = 2,
    ACTIONS(343), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(345), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3059] = 2,
    ACTIONS(351), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(353), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3070] = 2,
    ACTIONS(347), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(349), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3081] = 2,
    ACTIONS(245), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(247), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3092] = 2,
    ACTIONS(235), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(237), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3103] = 2,
    ACTIONS(335), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(337), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3114] = 2,
    ACTIONS(331), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(333), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3125] = 2,
    ACTIONS(323), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(325), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3136] = 2,
    ACTIONS(319), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(321), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3147] = 2,
    ACTIONS(315), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(317), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3158] = 2,
    ACTIONS(307), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(309), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3169] = 2,
    ACTIONS(231), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(233), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3180] = 2,
    ACTIONS(303), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(305), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3191] = 2,
    ACTIONS(299), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(301), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3202] = 2,
    ACTIONS(225), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(227), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3213] = 2,
    ACTIONS(217), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(219), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3224] = 2,
    ACTIONS(283), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(285), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3235] = 2,
    ACTIONS(279), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(281), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3246] = 2,
    ACTIONS(275), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(277), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3257] = 2,
    ACTIONS(271), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(273), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3268] = 2,
    ACTIONS(267), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(269), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3279] = 2,
    ACTIONS(213), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(215), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3290] = 2,
    ACTIONS(209), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(211), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3301] = 2,
    ACTIONS(261), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(263), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3312] = 2,
    ACTIONS(257), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(259), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3323] = 2,
    ACTIONS(253), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(255), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3334] = 2,
    ACTIONS(249), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(251), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3345] = 2,
    ACTIONS(339), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(341), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3356] = 2,
    ACTIONS(327), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(329), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3367] = 2,
    ACTIONS(287), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(289), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3378] = 2,
    ACTIONS(311), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(313), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3389] = 2,
    ACTIONS(295), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
    ACTIONS(297), 3,
      sym_comment,
      ts_builtin_sym_end,
      aux_sym__text_token1,
  [3400] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(365), 1,
      anon_sym_COLON,
    ACTIONS(367), 1,
      anon_sym_SLASH,
    ACTIONS(369), 1,
      sym_raw_text_expr,
  [3416] = 2,
    ACTIONS(373), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(371), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3426] = 2,
    ACTIONS(377), 1,
      anon_sym_EQ,
    ACTIONS(375), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3436] = 2,
    ACTIONS(381), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(379), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3446] = 2,
    ACTIONS(385), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(383), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3456] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(387), 1,
      anon_sym_COLON,
    ACTIONS(389), 1,
      anon_sym_SLASH,
  [3472] = 2,
    ACTIONS(393), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(391), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3482] = 2,
    ACTIONS(397), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(395), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3492] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(399), 1,
      anon_sym_COLON,
    ACTIONS(401), 1,
      anon_sym_SLASH,
  [3508] = 2,
    ACTIONS(405), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(403), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3518] = 2,
    ACTIONS(409), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(407), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3528] = 2,
    ACTIONS(413), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(411), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3538] = 1,
    ACTIONS(415), 5,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_EQ,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3546] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(387), 1,
      anon_sym_COLON,
    ACTIONS(401), 1,
      anon_sym_SLASH,
  [3562] = 2,
    ACTIONS(419), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(417), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3572] = 2,
    ACTIONS(423), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(421), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3582] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(389), 1,
      anon_sym_SLASH,
    ACTIONS(399), 1,
      anon_sym_COLON,
  [3598] = 2,
    ACTIONS(427), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(425), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3608] = 2,
    ACTIONS(431), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(429), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3618] = 5,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(365), 1,
      anon_sym_COLON,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(433), 1,
      anon_sym_SLASH,
  [3634] = 2,
    ACTIONS(437), 2,
      sym_comment,
      aux_sym__text_token1,
    ACTIONS(435), 3,
      anon_sym_LT,
      anon_sym_LBRACE_RBRACE,
      anon_sym_LBRACE,
  [3644] = 4,
    ACTIONS(439), 1,
      anon_sym_if,
    ACTIONS(441), 1,
      anon_sym_each,
    ACTIONS(443), 1,
      anon_sym_await,
    ACTIONS(445), 1,
      anon_sym_key,
  [3657] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(447), 1,
      anon_sym_SLASH,
  [3670] = 1,
    ACTIONS(449), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3677] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(433), 1,
      anon_sym_SLASH,
  [3690] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(367), 1,
      anon_sym_SLASH,
    ACTIONS(369), 1,
      sym_raw_text_expr,
  [3703] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(389), 1,
      anon_sym_SLASH,
  [3716] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(451), 1,
      anon_sym_SLASH,
  [3729] = 1,
    ACTIONS(453), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3736] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(455), 1,
      anon_sym_SLASH,
  [3749] = 1,
    ACTIONS(305), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3756] = 1,
    ACTIONS(457), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3763] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(401), 1,
      anon_sym_SLASH,
  [3776] = 1,
    ACTIONS(459), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3783] = 1,
    ACTIONS(461), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3790] = 4,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
    ACTIONS(463), 1,
      anon_sym_SLASH,
  [3803] = 1,
    ACTIONS(465), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3810] = 1,
    ACTIONS(415), 4,
      anon_sym_GT,
      anon_sym_EQ,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3817] = 2,
    ACTIONS(467), 1,
      anon_sym_EQ,
    ACTIONS(375), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3826] = 1,
    ACTIONS(459), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3832] = 1,
    ACTIONS(457), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3838] = 3,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(469), 1,
      anon_sym_AT,
    ACTIONS(471), 1,
      sym_raw_text_expr,
  [3848] = 1,
    ACTIONS(465), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3854] = 3,
    ACTIONS(473), 1,
      sym__start_tag_name,
    ACTIONS(475), 1,
      sym__script_start_tag_name,
    ACTIONS(477), 1,
      sym__style_start_tag_name,
  [3864] = 3,
    ACTIONS(361), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_POUND,
    ACTIONS(369), 1,
      sym_raw_text_expr,
  [3874] = 3,
    ACTIONS(479), 1,
      anon_sym_LT_SLASH,
    ACTIONS(481), 1,
      sym_raw_text,
    STATE(89), 1,
      sym_end_tag,
  [3884] = 3,
    ACTIONS(479), 1,
      anon_sym_LT_SLASH,
    ACTIONS(483), 1,
      sym_raw_text,
    STATE(94), 1,
      sym_end_tag,
  [3894] = 3,
    ACTIONS(475), 1,
      sym__script_start_tag_name,
    ACTIONS(477), 1,
      sym__style_start_tag_name,
    ACTIONS(485), 1,
      sym__start_tag_name,
  [3904] = 1,
    ACTIONS(453), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3910] = 1,
    ACTIONS(461), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3916] = 1,
    ACTIONS(449), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3922] = 3,
    ACTIONS(487), 1,
      anon_sym_LT_SLASH,
    ACTIONS(489), 1,
      sym_raw_text,
    STATE(83), 1,
      sym_end_tag,
  [3932] = 1,
    ACTIONS(305), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3938] = 3,
    ACTIONS(487), 1,
      anon_sym_LT_SLASH,
    ACTIONS(491), 1,
      sym_raw_text,
    STATE(81), 1,
      sym_end_tag,
  [3948] = 2,
    ACTIONS(487), 1,
      anon_sym_LT_SLASH,
    STATE(70), 1,
      sym_end_tag,
  [3955] = 2,
    ACTIONS(493), 1,
      anon_sym_then,
    ACTIONS(495), 1,
      anon_sym_catch,
  [3962] = 2,
    ACTIONS(497), 1,
      anon_sym_RBRACE,
    ACTIONS(499), 1,
      sym_raw_text_expr,
  [3969] = 2,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      aux_sym_quoted_attribute_value_token2,
  [3976] = 2,
    ACTIONS(501), 1,
      anon_sym_SQUOTE,
    ACTIONS(505), 1,
      aux_sym_quoted_attribute_value_token1,
  [3983] = 1,
    ACTIONS(507), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [3988] = 2,
    ACTIONS(509), 1,
      anon_sym_RBRACE,
    ACTIONS(511), 1,
      sym_raw_text_expr,
  [3995] = 2,
    ACTIONS(513), 1,
      sym_raw_text_expr,
    ACTIONS(515), 1,
      sym_raw_text_await,
  [4002] = 2,
    ACTIONS(517), 1,
      sym_raw_text_expr,
    ACTIONS(519), 1,
      sym_raw_text_each,
  [4009] = 2,
    ACTIONS(521), 1,
      anon_sym_RBRACE,
    ACTIONS(523), 1,
      sym_raw_text_expr,
  [4016] = 2,
    ACTIONS(525), 1,
      anon_sym_RBRACE,
    ACTIONS(527), 1,
      sym_raw_text_expr,
  [4023] = 2,
    ACTIONS(529), 1,
      anon_sym_RBRACE,
    ACTIONS(531), 1,
      anon_sym_if,
  [4030] = 1,
    ACTIONS(533), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4035] = 1,
    ACTIONS(535), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4040] = 2,
    ACTIONS(537), 1,
      anon_sym_RBRACE,
    ACTIONS(539), 1,
      sym_raw_text_expr,
  [4047] = 1,
    ACTIONS(541), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4052] = 2,
    ACTIONS(487), 1,
      anon_sym_LT_SLASH,
    STATE(68), 1,
      sym_end_tag,
  [4059] = 2,
    ACTIONS(543), 1,
      anon_sym_DQUOTE,
    ACTIONS(545), 1,
      aux_sym_quoted_attribute_value_token2,
  [4066] = 2,
    ACTIONS(479), 1,
      anon_sym_LT_SLASH,
    STATE(88), 1,
      sym_end_tag,
  [4073] = 2,
    ACTIONS(479), 1,
      anon_sym_LT_SLASH,
    STATE(105), 1,
      sym_end_tag,
  [4080] = 2,
    ACTIONS(543), 1,
      anon_sym_SQUOTE,
    ACTIONS(547), 1,
      aux_sym_quoted_attribute_value_token1,
  [4087] = 1,
    ACTIONS(549), 1,
      anon_sym_html,
  [4091] = 1,
    ACTIONS(551), 1,
      anon_sym_RBRACE,
  [4095] = 1,
    ACTIONS(553), 1,
      sym_raw_text_expr,
  [4099] = 1,
    ACTIONS(555), 1,
      anon_sym_RBRACE,
  [4103] = 1,
    ACTIONS(557), 1,
      anon_sym_then,
  [4107] = 1,
    ACTIONS(559), 1,
      anon_sym_RBRACE,
  [4111] = 1,
    ACTIONS(561), 1,
      anon_sym_RBRACE,
  [4115] = 1,
    ACTIONS(563), 1,
      anon_sym_key,
  [4119] = 1,
    ACTIONS(565), 1,
      anon_sym_as,
  [4123] = 1,
    ACTIONS(567), 1,
      anon_sym_RBRACE,
  [4127] = 1,
    ACTIONS(569), 1,
      anon_sym_RBRACE,
  [4131] = 1,
    ACTIONS(571), 1,
      anon_sym_await,
  [4135] = 1,
    ACTIONS(573), 1,
      anon_sym_RBRACE,
  [4139] = 1,
    ACTIONS(575), 1,
      anon_sym_RBRACE,
  [4143] = 1,
    ACTIONS(577), 1,
      sym__end_tag_name,
  [4147] = 1,
    ACTIONS(579), 1,
      anon_sym_RBRACE,
  [4151] = 1,
    ACTIONS(581), 1,
      anon_sym_if,
  [4155] = 1,
    ACTIONS(583), 1,
      anon_sym_RBRACE,
  [4159] = 1,
    ACTIONS(585), 1,
      anon_sym_else,
  [4163] = 1,
    ACTIONS(587), 1,
      anon_sym_GT,
  [4167] = 1,
    ACTIONS(589), 1,
      sym_raw_text_expr,
  [4171] = 1,
    ACTIONS(591), 1,
      sym_raw_text_expr,
  [4175] = 1,
    ACTIONS(593), 1,
      sym_raw_text_expr,
  [4179] = 1,
    ACTIONS(595), 1,
      ts_builtin_sym_end,
  [4183] = 1,
    ACTIONS(597), 1,
      anon_sym_RBRACE,
  [4187] = 1,
    ACTIONS(599), 1,
      sym_raw_text_expr,
  [4191] = 1,
    ACTIONS(601), 1,
      anon_sym_RBRACE,
  [4195] = 1,
    ACTIONS(603), 1,
      anon_sym_RBRACE,
  [4199] = 1,
    ACTIONS(605), 1,
      anon_sym_RBRACE,
  [4203] = 1,
    ACTIONS(607), 1,
      anon_sym_RBRACE,
  [4207] = 1,
    ACTIONS(609), 1,
      anon_sym_GT,
  [4211] = 1,
    ACTIONS(611), 1,
      anon_sym_RBRACE,
  [4215] = 1,
    ACTIONS(613), 1,
      anon_sym_SQUOTE,
  [4219] = 1,
    ACTIONS(613), 1,
      anon_sym_DQUOTE,
  [4223] = 1,
    ACTIONS(615), 1,
      anon_sym_RBRACE,
  [4227] = 1,
    ACTIONS(617), 1,
      anon_sym_RBRACE,
  [4231] = 1,
    ACTIONS(619), 1,
      anon_sym_each,
  [4235] = 1,
    ACTIONS(495), 1,
      anon_sym_catch,
  [4239] = 1,
    ACTIONS(621), 1,
      anon_sym_html,
  [4243] = 1,
    ACTIONS(623), 1,
      sym__end_tag_name,
  [4247] = 1,
    ACTIONS(625), 1,
      sym_raw_text_expr,
  [4251] = 1,
    ACTIONS(627), 1,
      anon_sym_if,
  [4255] = 1,
    ACTIONS(629), 1,
      anon_sym_RBRACE,
  [4259] = 1,
    ACTIONS(631), 1,
      anon_sym_each,
  [4263] = 1,
    ACTIONS(633), 1,
      anon_sym_await,
  [4267] = 1,
    ACTIONS(635), 1,
      anon_sym_RBRACE,
  [4271] = 1,
    ACTIONS(637), 1,
      anon_sym_DQUOTE,
  [4275] = 1,
    ACTIONS(639), 1,
      anon_sym_key,
  [4279] = 1,
    ACTIONS(637), 1,
      anon_sym_SQUOTE,
  [4283] = 1,
    ACTIONS(641), 1,
      anon_sym_RBRACE,
  [4287] = 1,
    ACTIONS(643), 1,
      anon_sym_RBRACE,
  [4291] = 1,
    ACTIONS(645), 1,
      anon_sym_RBRACE,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 65,
  [SMALL_STATE(4)] = 130,
  [SMALL_STATE(5)] = 195,
  [SMALL_STATE(6)] = 260,
  [SMALL_STATE(7)] = 325,
  [SMALL_STATE(8)] = 390,
  [SMALL_STATE(9)] = 455,
  [SMALL_STATE(10)] = 520,
  [SMALL_STATE(11)] = 585,
  [SMALL_STATE(12)] = 650,
  [SMALL_STATE(13)] = 715,
  [SMALL_STATE(14)] = 780,
  [SMALL_STATE(15)] = 843,
  [SMALL_STATE(16)] = 906,
  [SMALL_STATE(17)] = 967,
  [SMALL_STATE(18)] = 1028,
  [SMALL_STATE(19)] = 1091,
  [SMALL_STATE(20)] = 1152,
  [SMALL_STATE(21)] = 1215,
  [SMALL_STATE(22)] = 1276,
  [SMALL_STATE(23)] = 1336,
  [SMALL_STATE(24)] = 1393,
  [SMALL_STATE(25)] = 1450,
  [SMALL_STATE(26)] = 1507,
  [SMALL_STATE(27)] = 1564,
  [SMALL_STATE(28)] = 1621,
  [SMALL_STATE(29)] = 1678,
  [SMALL_STATE(30)] = 1735,
  [SMALL_STATE(31)] = 1792,
  [SMALL_STATE(32)] = 1849,
  [SMALL_STATE(33)] = 1906,
  [SMALL_STATE(34)] = 1963,
  [SMALL_STATE(35)] = 2020,
  [SMALL_STATE(36)] = 2077,
  [SMALL_STATE(37)] = 2134,
  [SMALL_STATE(38)] = 2191,
  [SMALL_STATE(39)] = 2248,
  [SMALL_STATE(40)] = 2305,
  [SMALL_STATE(41)] = 2362,
  [SMALL_STATE(42)] = 2383,
  [SMALL_STATE(43)] = 2404,
  [SMALL_STATE(44)] = 2427,
  [SMALL_STATE(45)] = 2448,
  [SMALL_STATE(46)] = 2471,
  [SMALL_STATE(47)] = 2494,
  [SMALL_STATE(48)] = 2517,
  [SMALL_STATE(49)] = 2529,
  [SMALL_STATE(50)] = 2541,
  [SMALL_STATE(51)] = 2553,
  [SMALL_STATE(52)] = 2565,
  [SMALL_STATE(53)] = 2585,
  [SMALL_STATE(54)] = 2597,
  [SMALL_STATE(55)] = 2617,
  [SMALL_STATE(56)] = 2629,
  [SMALL_STATE(57)] = 2641,
  [SMALL_STATE(58)] = 2661,
  [SMALL_STATE(59)] = 2673,
  [SMALL_STATE(60)] = 2685,
  [SMALL_STATE(61)] = 2697,
  [SMALL_STATE(62)] = 2709,
  [SMALL_STATE(63)] = 2721,
  [SMALL_STATE(64)] = 2741,
  [SMALL_STATE(65)] = 2753,
  [SMALL_STATE(66)] = 2765,
  [SMALL_STATE(67)] = 2777,
  [SMALL_STATE(68)] = 2789,
  [SMALL_STATE(69)] = 2801,
  [SMALL_STATE(70)] = 2813,
  [SMALL_STATE(71)] = 2825,
  [SMALL_STATE(72)] = 2837,
  [SMALL_STATE(73)] = 2849,
  [SMALL_STATE(74)] = 2861,
  [SMALL_STATE(75)] = 2873,
  [SMALL_STATE(76)] = 2885,
  [SMALL_STATE(77)] = 2897,
  [SMALL_STATE(78)] = 2909,
  [SMALL_STATE(79)] = 2921,
  [SMALL_STATE(80)] = 2933,
  [SMALL_STATE(81)] = 2945,
  [SMALL_STATE(82)] = 2957,
  [SMALL_STATE(83)] = 2969,
  [SMALL_STATE(84)] = 2981,
  [SMALL_STATE(85)] = 2993,
  [SMALL_STATE(86)] = 3005,
  [SMALL_STATE(87)] = 3025,
  [SMALL_STATE(88)] = 3037,
  [SMALL_STATE(89)] = 3048,
  [SMALL_STATE(90)] = 3059,
  [SMALL_STATE(91)] = 3070,
  [SMALL_STATE(92)] = 3081,
  [SMALL_STATE(93)] = 3092,
  [SMALL_STATE(94)] = 3103,
  [SMALL_STATE(95)] = 3114,
  [SMALL_STATE(96)] = 3125,
  [SMALL_STATE(97)] = 3136,
  [SMALL_STATE(98)] = 3147,
  [SMALL_STATE(99)] = 3158,
  [SMALL_STATE(100)] = 3169,
  [SMALL_STATE(101)] = 3180,
  [SMALL_STATE(102)] = 3191,
  [SMALL_STATE(103)] = 3202,
  [SMALL_STATE(104)] = 3213,
  [SMALL_STATE(105)] = 3224,
  [SMALL_STATE(106)] = 3235,
  [SMALL_STATE(107)] = 3246,
  [SMALL_STATE(108)] = 3257,
  [SMALL_STATE(109)] = 3268,
  [SMALL_STATE(110)] = 3279,
  [SMALL_STATE(111)] = 3290,
  [SMALL_STATE(112)] = 3301,
  [SMALL_STATE(113)] = 3312,
  [SMALL_STATE(114)] = 3323,
  [SMALL_STATE(115)] = 3334,
  [SMALL_STATE(116)] = 3345,
  [SMALL_STATE(117)] = 3356,
  [SMALL_STATE(118)] = 3367,
  [SMALL_STATE(119)] = 3378,
  [SMALL_STATE(120)] = 3389,
  [SMALL_STATE(121)] = 3400,
  [SMALL_STATE(122)] = 3416,
  [SMALL_STATE(123)] = 3426,
  [SMALL_STATE(124)] = 3436,
  [SMALL_STATE(125)] = 3446,
  [SMALL_STATE(126)] = 3456,
  [SMALL_STATE(127)] = 3472,
  [SMALL_STATE(128)] = 3482,
  [SMALL_STATE(129)] = 3492,
  [SMALL_STATE(130)] = 3508,
  [SMALL_STATE(131)] = 3518,
  [SMALL_STATE(132)] = 3528,
  [SMALL_STATE(133)] = 3538,
  [SMALL_STATE(134)] = 3546,
  [SMALL_STATE(135)] = 3562,
  [SMALL_STATE(136)] = 3572,
  [SMALL_STATE(137)] = 3582,
  [SMALL_STATE(138)] = 3598,
  [SMALL_STATE(139)] = 3608,
  [SMALL_STATE(140)] = 3618,
  [SMALL_STATE(141)] = 3634,
  [SMALL_STATE(142)] = 3644,
  [SMALL_STATE(143)] = 3657,
  [SMALL_STATE(144)] = 3670,
  [SMALL_STATE(145)] = 3677,
  [SMALL_STATE(146)] = 3690,
  [SMALL_STATE(147)] = 3703,
  [SMALL_STATE(148)] = 3716,
  [SMALL_STATE(149)] = 3729,
  [SMALL_STATE(150)] = 3736,
  [SMALL_STATE(151)] = 3749,
  [SMALL_STATE(152)] = 3756,
  [SMALL_STATE(153)] = 3763,
  [SMALL_STATE(154)] = 3776,
  [SMALL_STATE(155)] = 3783,
  [SMALL_STATE(156)] = 3790,
  [SMALL_STATE(157)] = 3803,
  [SMALL_STATE(158)] = 3810,
  [SMALL_STATE(159)] = 3817,
  [SMALL_STATE(160)] = 3826,
  [SMALL_STATE(161)] = 3832,
  [SMALL_STATE(162)] = 3838,
  [SMALL_STATE(163)] = 3848,
  [SMALL_STATE(164)] = 3854,
  [SMALL_STATE(165)] = 3864,
  [SMALL_STATE(166)] = 3874,
  [SMALL_STATE(167)] = 3884,
  [SMALL_STATE(168)] = 3894,
  [SMALL_STATE(169)] = 3904,
  [SMALL_STATE(170)] = 3910,
  [SMALL_STATE(171)] = 3916,
  [SMALL_STATE(172)] = 3922,
  [SMALL_STATE(173)] = 3932,
  [SMALL_STATE(174)] = 3938,
  [SMALL_STATE(175)] = 3948,
  [SMALL_STATE(176)] = 3955,
  [SMALL_STATE(177)] = 3962,
  [SMALL_STATE(178)] = 3969,
  [SMALL_STATE(179)] = 3976,
  [SMALL_STATE(180)] = 3983,
  [SMALL_STATE(181)] = 3988,
  [SMALL_STATE(182)] = 3995,
  [SMALL_STATE(183)] = 4002,
  [SMALL_STATE(184)] = 4009,
  [SMALL_STATE(185)] = 4016,
  [SMALL_STATE(186)] = 4023,
  [SMALL_STATE(187)] = 4030,
  [SMALL_STATE(188)] = 4035,
  [SMALL_STATE(189)] = 4040,
  [SMALL_STATE(190)] = 4047,
  [SMALL_STATE(191)] = 4052,
  [SMALL_STATE(192)] = 4059,
  [SMALL_STATE(193)] = 4066,
  [SMALL_STATE(194)] = 4073,
  [SMALL_STATE(195)] = 4080,
  [SMALL_STATE(196)] = 4087,
  [SMALL_STATE(197)] = 4091,
  [SMALL_STATE(198)] = 4095,
  [SMALL_STATE(199)] = 4099,
  [SMALL_STATE(200)] = 4103,
  [SMALL_STATE(201)] = 4107,
  [SMALL_STATE(202)] = 4111,
  [SMALL_STATE(203)] = 4115,
  [SMALL_STATE(204)] = 4119,
  [SMALL_STATE(205)] = 4123,
  [SMALL_STATE(206)] = 4127,
  [SMALL_STATE(207)] = 4131,
  [SMALL_STATE(208)] = 4135,
  [SMALL_STATE(209)] = 4139,
  [SMALL_STATE(210)] = 4143,
  [SMALL_STATE(211)] = 4147,
  [SMALL_STATE(212)] = 4151,
  [SMALL_STATE(213)] = 4155,
  [SMALL_STATE(214)] = 4159,
  [SMALL_STATE(215)] = 4163,
  [SMALL_STATE(216)] = 4167,
  [SMALL_STATE(217)] = 4171,
  [SMALL_STATE(218)] = 4175,
  [SMALL_STATE(219)] = 4179,
  [SMALL_STATE(220)] = 4183,
  [SMALL_STATE(221)] = 4187,
  [SMALL_STATE(222)] = 4191,
  [SMALL_STATE(223)] = 4195,
  [SMALL_STATE(224)] = 4199,
  [SMALL_STATE(225)] = 4203,
  [SMALL_STATE(226)] = 4207,
  [SMALL_STATE(227)] = 4211,
  [SMALL_STATE(228)] = 4215,
  [SMALL_STATE(229)] = 4219,
  [SMALL_STATE(230)] = 4223,
  [SMALL_STATE(231)] = 4227,
  [SMALL_STATE(232)] = 4231,
  [SMALL_STATE(233)] = 4235,
  [SMALL_STATE(234)] = 4239,
  [SMALL_STATE(235)] = 4243,
  [SMALL_STATE(236)] = 4247,
  [SMALL_STATE(237)] = 4251,
  [SMALL_STATE(238)] = 4255,
  [SMALL_STATE(239)] = 4259,
  [SMALL_STATE(240)] = 4263,
  [SMALL_STATE(241)] = 4267,
  [SMALL_STATE(242)] = 4271,
  [SMALL_STATE(243)] = 4275,
  [SMALL_STATE(244)] = 4279,
  [SMALL_STATE(245)] = 4283,
  [SMALL_STATE(246)] = 4287,
  [SMALL_STATE(247)] = 4291,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(164),
  [92] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2),
  [94] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(22),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(22),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(162),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(168),
  [150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(36),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(36),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(165),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(133),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(221),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 3),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 3),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 3),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 3),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_statement, 3),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_statement, 3),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_statement, 3),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_statement, 3),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 3),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 3),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_tag, 3),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_tag, 3),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_expr, 4),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_expr, 4),
  [239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(158),
  [242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(236),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 4),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 4),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_statement, 3),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_statement, 3),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_statement, 3),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_statement, 3),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 2),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 2),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_statement, 2),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_statement, 2),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_statement, 3),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_statement, 3),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_statement, 2),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_statement, 2),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 2),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 3),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 3),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_expr, 5),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_expr, 5),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 3),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 3),
  [295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_end_expr, 4),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_end_expr, 4),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 3),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 3),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 3),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 3),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_end_expr, 4),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_end_expr, 4),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_statement, 2),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_statement, 2),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_statement, 2),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_statement, 2),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_statement, 2),
  [325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_statement, 2),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_end_expr, 4),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_end_expr, 4),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 2),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 2),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 2),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 2),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_end_expr, 4),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_end_expr, 4),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 2),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 2),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 2),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 2),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 1),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 4),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 4),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_start_expr, 5),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_start_expr, 5),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_start_expr, 5),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_start_expr, 5),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_expr, 4),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_expr, 4),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_start_expr, 5),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_start_expr, 5),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_start_expr, 5),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_start_expr, 5),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_expr, 4),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_expr, 4),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_expr, 5),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_expr, 5),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expr, 4),
  [413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expr, 4),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_expr, 6),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_expr, 6),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_start_expr, 7, .production_id = 2),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_start_expr, 7, .production_id = 2),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_start_expr, 7),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_start_expr, 7),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expr, 5),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expr, 5),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_expr, 5),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_expr, 5),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 3),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 2),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 1),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_attribute_value, 1),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 1),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 4),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 3),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 3),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 4),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [595] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_svelte_external_scanner_create(void);
void tree_sitter_svelte_external_scanner_destroy(void *);
bool tree_sitter_svelte_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_svelte_external_scanner_serialize(void *, char *);
void tree_sitter_svelte_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_svelte(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_svelte_external_scanner_create,
      tree_sitter_svelte_external_scanner_destroy,
      tree_sitter_svelte_external_scanner_scan,
      tree_sitter_svelte_external_scanner_serialize,
      tree_sitter_svelte_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
